;       Last change    August 1993
(in-package number)

(defun print-n-info (item)
  (if (null item)
      'unknown
      item)
  )

; print number information

(defun print-number (brief key node)
  (unless (null node)
  (print-line key 
	     #\tab "Node " (epinumber-name node) #\tab #\tab (epinumber-ntype node) *nl*
             #\tab "Minimum " #\tab (print-n-info (epinumber-min node)) *nl*
             #\tab "Maximum " #\tab (print-n-info (epinumber-max node)) )
  (unless brief
	  (print-line #\tab "Descendants " #\tab "Strict   " #\tab 
		     (cond ((epinumber-strict-next node))
			   (t " "))
		     *nl* #\tab #\tab #\tab "Nonstrict" #\tab 
		     (cond ((epinumber-next node))
			   (t " "))) 
	  (print-line #\tab "Anscestors  " #\tab "Strict   " #\tab 
		     (cond ((epinumber-strict-prev node))
			   (t " "))
		     *nl* #\tab #\tab #\tab "Nonstrict" #\tab
		     (cond ((epinumber-prev node))
			   (t " "))) 
	  ))
  )

(defun print-numbers (brief nm)
  (maphash #'(lambda (key node) (print-number brief key node)) nm)
)

(defun print-net (context &aux
			  (usec context))
  (if (null context)
      (setq usec '/))
  (let ((context-array (retrieve-specialist-info *environment*
						 'number)))
    (if (null context-array)
	nil
      (gethash usec context-array))))


(set-display-function 'epilog::number-info 'number-info 
  "Displays the number graph - for all or a named point")

(defun number-info (brief &rest args &aux 
		          (point (car args))
		          (context (cadr args))
		          (net (print-net context)))
  (when (not (null net))
	(if (or (null point)
		(equal point 'epilog::all))
	    (let ()
	         (print-line "Numbers for Context" #\tab 
			    (if (null context) '/ context))
                 (print-numbers brief (number-subnet-numbers net))
		 )
	    (print-number brief point (findnumber net point))
	    )
	)
  )

