;       Last change    August 1993
(in-package part)

;        Routines to get and create part nets and parts

; Getnet returns the part net corresponding to the context given. If no
; such net exists, one is created.

(defun getnet (context)
  (let ((context-array (retrieve-specialist-info
			*environment*
			'part
			(lambda ()
			  (make-hash-table :test 'eql
					   :size '100
					   :rehash-size '10
					   :rehash-threshold '.8)))))
    (when (null (geth context context-array))
      (seth context context-array (newnet context)))
    (geth context context-array)))

; determine net gets the part net associated with the subnet for the
; netname given (/concpet1/concept2/...)

(defun determine-net (netname)
  (if netname
      (getnet netname)
    (getnet '/)))

; Getpart returns the part for item in the part net. If there is no
; entry, once is created and returned.

(defun getpart (net item &aux
		     (narray (part-subnet-parts net)))
  (when (null (geth item narray))
	(change-hash item narray (make-part :name item))
	)
  (geth item narray)
  )

; Findpart returns the part in the net corresponding to item if there
; is one. If not, nil is returned

(defun findpart (net item)
  (if (or (null net) (null item))
      nil
      (geth item (part-subnet-parts net))
      )
  )

; Newnet creates a new part net, including the set table

(defun newnet (ident &aux
		     ; hash table for set
		     (nt (make-hash-table :test 'eql
					  :size '100
					  :rehash-size '10
                                          :rehash-threshold '.8))) ; changed!
                                           ;; threshold value changed from 9
                                           ;; [2/24/95 CH]


  (make-part-subnet :identifier ident
		   :parts nt)
  )
