;       Last change    August 1993
(in-package user)
(eval-when (load compile eval)
(provide 'specialist-interface)
(require 'lib "epilog:lib;lib")
(require 'epilib "epilog:epilib;epilib")
(defpackage specialist-interface (:nicknames spec)
  (:use user lisp #+lucid lucid-common-lisp #-lucid common-lisp #+excl excl lib epilib)
  (:export
       ;  exactly those routines used by specialists
          term-type pred-type op-type wff-type entity-type quant-type
          operator-result operator-args operator-type
          neg-p wff-p pred-p term-p operator-p quantifier-p function-p
          variable-p function-term-p record-p quoted-expression-p
	  quasi-quoted-expression is-quasi-quoted-expression
          type-pred-p skolem-constant-p lambda-pred-p type-lit-p
          print-info prop-pred prop-args is-negated
          logical-conn episodic-conn causal-conn is-lambda-pred is-lambda-expr
          is-pred is-function is-variable is-function-term
          is-quoted-expression is-record is-wff is-operator is-quantifier
          type-of-concept record-contents new-record

	  *sorts* *solutions* *quoted-indicators*

          ; Predefined quantifiers
	  L A E most many some few none WH The E!

          ; Predefined predicates
          ~> <=> implies and or because cause-of ** * @ _ true member-of 
	  member-of-0 part-of $  => <= >= ->   

          ; Predefined comparison and evaluation results
          yes no unknown inconsistent
          disjoint contains overlaps subsumes subsumed equivalent

          ; Variable and constant symbols
          C X Y Z U V W

          ; Entity types and properties
          wff pred operator quantifier op quant term meta-entity entity
          lambda function quoted-expression record indef variable
          indicators specialists result args arguments predicate constant
          main restrict conditional equivalence subject object iobj
          meaning-postulate assumption negated sort print skol-const matchable
	  simplification-schema
          prefix quantified modified episodic causal logical
          +trigger -trigger +keys -keys +other -other lit-classes
          wh-vars e-vars

          ; Predefined sorts
          episode ep event number num propos prop integer int real set
          time string str

	  combine-subgoal find-sort compatible-sorts
	  create-predicate create-function create-operator

	  ; Normalization
	  normalize normalize-term normalize-pred normalize-op normalize-wff
	  negate make-variable
	  *expand-names* 
          add-sort add-function add-predicate add-quantifier add-operator
          add-operator-type

	  ; Predicate splitting
	  *check-pred-parts* pred-parts

          ; Predefined operator types
          wff-op pred-op term-op
           
          ; Predefined Operators
          not ~ nec poss prob almost sort-of very plural plur coll coll-of
          K K1 to that whether answer-to adv-s adv-a ly nearly mos
          extremely severely member-type-of
	  qquote qq
 
          ; Predefined Functions
          pair set-of-all set-of cardinality-of
          start-of end-of date

	  ; Specialists
	  function-eval interested-party spec-eval spec-entry spec-test 
	  spec-assert spec-int
	  *maximum-effort* *specialist-entry-effort* *specialist-eval-effort*
	  *spec-evaluate* *spec-enter* *spec-assert* *fwd-spec-compare*
	  *spec-compare-lits* *spec-compare-preds* *spec-eval-fn*
	  *assertions* *spec-simplify* *spec-assumptions*
	  *current-netname* *current-literal* *flattened-lit*
	  *current-embedding*
	  *active-specialists* *available-specialists* 
	  make-spec-inference
	  set-specialist active-specialists available-specialists
	  specialist-sorts set-arg-sorts define-specialist use-spec
	  prep-arg check-constant non-constant-arg number-arg
	  unify-lists arg-sub-list make-sub-element spec-eval-fn 
	  eval-with-spec
	  evalarg spec-eval-args spec-evaluate spec-enter spec-compare-lits
	  spec-incompatible-lits spec-compatible-lits spec-effort
	  incompatible-with-eval 
	  function-with-rel-pred make-fn-arg
	  spec-changed-concept add-interested-party constant-arg
	  *fn-simplified*
	  spec-compare-preds
	  episode-specialist type-specialist part-specialist  
          other-specialist meta-specialist hier-specialist
	  avail-specs active-specs specs
	  other-predicate other-function other-entry-rtn entry-rtn
	  retrieve-specialist-info

	  ; Unification & Comparison
	  *fix-unify* *unify-sorts*
	  compare-wffs compare-arglists compatible incompatible
	  make-comparison-info 
	  comparison-info-wff1 comparison-info-wff2 
	  comparison-info-lit1 comparison-info-lit2 
	  comparison-info-subs1 comparison-info-subs2 
	  comparison-info-residue1 comparison-info-residue2 
	  compare-predicates 

	  ; Substitution
	  make-prop substitute-prop substitute-term print-trace-subs print-subs

	  ; Hierarchies
	  *hierarchies* *all-hierarchies* part-type 
          add-hier set-hier-type number-hier hier hier-print add-indicate 
          add-topic print-hier hier-rel hier-test add-sort-to-hier add-part-hier
	  *remainder-indicators* hier-property

          ;Hierarchy properties
	  exclusion overlap part parts hier-type properties exhaustive
	  non-exhaustive normal-level

	  part-hier part-type-hier pred-hier root total bounds
	  compare-hier-res get-all-super

	  ;Familiar parts
	  *familiar-parts* familiar-parts familiar
	  *part-hierarchy-types* form state

	  grab-types get-sub get-super

	  ; Equivalence sets
	  save-equivalence get-equivalence
	  ))
(unless (find-package 'spec) (make-package 'spec)))
(in-package spec)
(load "epilog:spec;interface")

